# CustomCompoundBondForce Class Reference

This class supports a wide variety of bonded interactions. More...

Inheritance diagram for CustomCompoundBondForce:

List of all members.

## Public Member Functions

def | __del__
| __del__(self)
def | getNumParticlesPerBond
| getNumParticlesPerBond(self) -> int
def | getNumBonds
| getNumBonds(self) -> int
def | getNumPerBondParameters
| getNumPerBondParameters(self) -> int
def | getNumGlobalParameters
| getNumGlobalParameters(self) -> int
def | getNumTabulatedFunctions
| getNumTabulatedFunctions(self) -> int
def | getNumFunctions
| getNumFunctions(self) -> int
def | getEnergyFunction
| getEnergyFunction(self) -> string
def | setEnergyFunction
| setEnergyFunction(self, string energy)
def | addPerBondParameter
| addPerBondParameter(self, string name) -> int
def | getPerBondParameterName
| getPerBondParameterName(self, int index) -> string
def | setPerBondParameterName
| setPerBondParameterName(self, int index, string name)
def | addGlobalParameter
| addGlobalParameter(self, string name, double defaultValue) -> int
def | getGlobalParameterName
| getGlobalParameterName(self, int index) -> string
def | setGlobalParameterName
| setGlobalParameterName(self, int index, string name)
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(self, int index) -> double
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(self, int index, double defaultValue)
def | addBond
| addBond(self, vectori particles, vectord parameters) -> int
def | getBondParameters
| getBondParameters(self, int index)
def | setBondParameters
| setBondParameters(self, int index, vectori particles, vectord parameters)
def | addTabulatedFunction
| addTabulatedFunction(self, string name, TabulatedFunction function) -> int
def | getTabulatedFunction
| getTabulatedFunction(self, int index) -> TabulatedFunction getTabulatedFunction(self, int index) -> TabulatedFunction
def | getTabulatedFunctionName
| getTabulatedFunctionName(self, int index) -> string
def | addFunction
| addFunction(self, string name, vectord values, double min, double max) -> int
def | getFunctionParameters
| getFunctionParameters(self, int index)
def | setFunctionParameters
| setFunctionParameters(self, int index, string name, vectord values, double min, double max)
def | updateParametersInContext
| updateParametersInContext(self, Context context)
def | __init__
| __init__(self, int numParticles, string energy) -> CustomCompoundBondForce __init__(self, CustomCompoundBondForce other) -> CustomCompoundBondForce

## Public Attributes

| this

## Detailed Description

This class supports a wide variety of bonded interactions.

It defines a "bond" as a single energy term that depends on the positions of a fixed set of particles. The number of particles involved in a bond, and how the energy depends on their positions, is configurable. It may depend on the positions of individual particles, the distances between pairs of particles, the angles formed by sets of three particles, and the dihedral angles formed by sets of four particles.

We refer to the particles in a bond as p1, p2, p3, etc. For each bond, CustomCompoundBondForce evaluates a user supplied algebraic expression to determine the interaction energy. The expression may depend on the following variables and functions:

- x1, y1, z1, x2, y2, z2, etc.: The x, y, and z coordinates of the particle positions. For example, x1 is the x coordinate of particle p1, and y3 is the y coordinate of particle p3.

- distance(p1, p2): the distance between particles p1 and p2 (where "p1" and "p2" may be replaced by the names of whichever particles you want to calculate the distance between).

- angle(p1, p2, p3): the angle formed by the three specified particles.

- dihedral(p1, p2, p3, p4): the dihedral angle formed by the four specified particles.

The expression also may involve tabulated functions, and may depend on arbitrary global and per-bond parameters.

To use this class, create a CustomCompoundBondForce object, passing an algebraic expression to the constructor that defines the interaction energy of each bond. Then call addPerBondParameter() to define per-bond parameters and addGlobalParameter() to define global parameters. The values of per-bond parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context.setParameter().

Next, call addBond() to define bonds and specify their parameter values. After a bond has been added, you can modify its parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomCompoundBondForce that implements a Urey-Bradley potential. This is an interaction between three particles that depends on the angle formed by p1-p2-p3, and on the distance between p1 and p3.

`CustomCompoundBondForce* force = new CustomCompoundBondForce(3, "0.5*(kangle*(angle(p1,p2,p3)-theta0)^2+kbond*(distance(p1,p3)-r0)^2)");`

This force depends on four parameters: kangle, kbond, theta0, and r0. The following code defines these as per-bond parameters:

``

    force->addPerBondParameter("kangle");
    force->addPerBondParameter("kbond");
    force->addPerBondParameter("theta0");
    force->addPerBondParameter("r0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self, int numParticles, string energy) -> CustomCompoundBondForce __init__(self, CustomCompoundBondForce other) -> CustomCompoundBondForce

Create a CustomCompoundBondForce.

Parameters:

  | numParticles | the number of particles used to define each bond
  | energy | an algebraic expression giving the interaction energy of each bond as a function of particle positions, inter-particle distances, angles, and dihedrals, and any global and per-bond parameters

def addBond | ( |  | self,
|  |  | args |
| ) |  |  |

addBond(self, vectori particles, vectord parameters) -> int

Add a bond to the force

Parameters:

  | particles | the indices of the particles the bond depends on
  | parameters | the list of per-bond parameter values for the new bond

def addFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addFunction(self, string name, vectord values, double min, double max) -> int

Add a tabulated function that may appear in the energy expression.

def addGlobalParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addGlobalParameter(self, string name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

def addPerBondParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerBondParameter(self, string name) -> int

Add a new per-bond parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

def addTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addTabulatedFunction(self, string name, TabulatedFunction function) -> int

Add a tabulated function that may appear in the energy expression.

Parameters:

  | name | the name of the function as it appears in expressions
  | function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

def getBondParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getBondParameters(self, int index)

Get the properties of a bond.

Parameters:

  | index | the index of the bond to get
  | particles | the indices of the particles in the bond
  | parameters | the list of per-bond parameter values for the bond

def getEnergyFunction | ( |  | self | ) |

getEnergyFunction(self) -> string

Get the algebraic expression that gives the interaction energy of each bond

def getFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getFunctionParameters(self, int index)

Get the parameters for a tabulated function that may appear in the energy expression.

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterDefaultValue(self, int index) -> double

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

def getGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterName(self, int index) -> string

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getNumBonds | ( |  | self | ) |

getNumBonds(self) -> int

Get the number of bonds for which force field parameters have been defined.

def getNumFunctions | ( |  | self | ) |

getNumFunctions(self) -> int

Get the number of tabulated functions that have been defined.

def getNumGlobalParameters | ( |  | self | ) |

getNumGlobalParameters(self) -> int

Get the number of global parameters that the interaction depends on.

def getNumParticlesPerBond | ( |  | self | ) |

getNumParticlesPerBond(self) -> int

Get the number of particles used to define each bond.

def getNumPerBondParameters | ( |  | self | ) |

getNumPerBondParameters(self) -> int

Get the number of per-bond parameters that the interaction depends on.

def getNumTabulatedFunctions | ( |  | self | ) |

getNumTabulatedFunctions(self) -> int

Get the number of tabulated functions that have been defined.

def getPerBondParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerBondParameterName(self, int index) -> string

Get the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunction(self, int index) -> TabulatedFunction getTabulatedFunction(self, int index) -> TabulatedFunction

Get a reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

def getTabulatedFunctionName | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunctionName(self, int index) -> string

Get the name of a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

def setBondParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setBondParameters(self, int index, vectori particles, vectord parameters)

Set the properties of a bond.

Parameters:

  | index | the index of the bond group to set
  | particles | the indices of the particles in the bond
  | parameters | the list of per-bond parameter values for the bond

def setEnergyFunction | ( |  | self,
|  |  | args |
| ) |  |  |

setEnergyFunction(self, string energy)

Set the algebraic expression that gives the interaction energy of each bond

def setFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setFunctionParameters(self, int index, string name, vectord values, double min, double max)

Set the parameters for a tabulated function that may appear in the energy expression.

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterDefaultValue(self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

def setGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterName(self, int index, string name)

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setPerBondParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerBondParameterName(self, int index, string name)

Set the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(self, Context context)

Update the per-bond parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-bond parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

## Member Data Documentation

this

The documentation for this class was generated from the following file:

- openmm.py